package com.seer.teach.common.enums;

import com.seer.teach.common.validation.ArrayValuable;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;
import java.util.Collection;

import static cn.hutool.core.util.ArrayUtil.firstMatch;

@AllArgsConstructor
@Getter
public enum AfterSaleStatusEnum implements ArrayValuable<Integer> {

    /**
     * 【没有申请】
     */
    NON_APPLY(0,"没有申请", "没有申请"),

    /**
     * 【申请售后】
     */
    APPLY(10,"申请中", "申请退款"),
    /**
     * 卖家通过售后；【商品待退货】
     */
    SELLER_AGREE(20, "卖家通过", "商家同意申请"),

    /**
     * 卖家拒绝售后；【卖家拒绝】
     */
    SELLER_REFUSE_APPLY(21, "卖家拒绝", "商家拒绝申请"),

    /**
     * 买家已发货，等待卖家收货；【商家待收货】
     */
    BUYER_DELIVERY(30,"买家已发货", "商家待收货"),
    /**
     * 卖家已收货，等待平台退款；等待退款【等待退款】
     */
    WAIT_REFUND(40, "卖家已收获", "商家收货，等待平台退款"),

    /**
     * 退款失败
     */
    REFUND_FAILED(52, "退款失败", "支付渠道退款失败"),

    /**
     * 完成退款【退款成功】
     */
    COMPLETE(56, "完成", "退款成功"),
    /**
     * 【买家取消】
     */
    BUYER_CANCEL(61, "买家取消售后", "取消退款"),
    /**
     * 卖家拒绝售后；商家拒绝【商家拒绝】
     */
    SELLER_DISAGREE(62,"卖家拒绝", "商家拒绝退款"),
    /**
     * 卖家拒绝收货，终止售后；【商家拒收货】
     */
    SELLER_REFUSE(63,"卖家拒绝收货", "商家拒绝收货"),
    ;

    public static final Integer[] ARRAYS = Arrays.stream(values()).map(AfterSaleStatusEnum::getStatus).toArray(Integer[]::new);

    /**
     * 进行中的售后状态
     *
     * 不包括已经结束的状态
     */
    public static final Collection<Integer> APPLYING_STATUSES = Arrays.asList(
            APPLY.getStatus(),
            SELLER_AGREE.getStatus(),
            BUYER_DELIVERY.getStatus(),
            WAIT_REFUND.getStatus()
    );

    /**
     * 状态
     */
    private final Integer status;
    /**
     * 状态名
     */
    private final String name;
    /**
     * 操作内容
     *
     * 目的：记录售后日志的内容
     */
    private final String content;

    @Override
    public Integer[] array() {
        return ARRAYS;
    }

    public static AfterSaleStatusEnum valueOf(Integer status) {
        return firstMatch(value -> value.getStatus().equals(status), values());
    }

}